'------------------------------------------------------
'          Copyright 2007-2008 BRZOZA
'             zegar-termometr.bas
'
'       Obsuga zegara RTC PCF8583 I2C
'       Obsuga termometru DS19B20
'------------------------------------------------------
'$sim
'$dbg

$regfile = "m128def.dat"
$crystal = 16000000
'$baud = 19200
'$hwstack = 40                                               ' Kada procedura x 2 bajty
'$swstack = 48                                               ' Kada zmienna lokalna + parametr przekazywany do prcedury X 2 bajty

$hwstack = 100
$swstack = 75
$framesize = 200


$external Waitms                                            ' one of the libs needs the waitms code

Config Date = Dmy , Separator = .                           ' the file system uses date and times
Config Clock = Soft                                         ' real clock installed
Config Serialin = Buffered , Size = 20                      ' do not use it in Simulator-terminal

Enable Interrupts

$include "config_mmc.bas"
$include "CONFIG_AVR-DOS.Bas"
$framesize = 60

$lib "glcdKS108.lib"                                        ' wywoanie biblioteki obsugujacej wywietlacza graficzny LCD

Declare Sub Init_eeprom
Declare Sub Odczyt_pcf(byval Stan As Byte)
Declare Function Klawisz() As Byte
Declare Sub Menu_glowne(poz As Byte)
Declare Sub Ustaw_czas
Declare Sub Ustaw_date
Declare Sub Inicjuj_ds(wys As Byte)
Declare Sub Dodaj_ds_do_eeprom(byval Wys As Byte)
Declare Function Lcdatcenter(byval Ciag As String , Byval Dod As Byte , Byval Roz As Byte) As Byte
Declare Sub Sprawdz_dostepnosc_1wire
Declare Function Czytaj() As Byte
Declare Sub Wyswietl_temp
Declare Sub Lcd_eeprom_graf

Dim Aaa As Byte
Config Portc = Output

Config Graphlcd = 128 * 64sed , Dataport = Porta , Controlport = Portd , Ce = 6 , Ce2 = 7 , Cd = 4 , Rd = 3 , Reset = 2 , Enable = 5

Do


Portc = $b00000001

For Aaa = 1 To 8

   Rotate Portc , Left                                      'rotate bits left
'   Print "Liczba=" ; Aaa
'   Lcd "Liczba=" ; A

'   Wait 1
'   Cls

Next

Loop


'konfiguracja I2C dla PCF8583
Config Sda = Portc.1
Config Scl = Portc.0

'konfiguracja 1wire
Config 1wire = Portc.7

'konfiguracja portu do obsugi przyciskw
Config Pinb.4 = Output
Config Pinb.5 = Output
Config Pinb.6 = Output
Config Pinb.7 = Output
Config Pinb.3 = Output

S1 Alias Pinb.4
S2 Alias Pinb.5
S3 Alias Pinb.6
S4 Alias Pinb.7
Kl Alias Pinb.3

Set Portb.4
Set Portb.5
Set Portb.6
Set Portb.7
Set Portb.3

Dim Godzina As Byte
Dim Minuta As Byte
Dim Sekunda As Byte
Dim Dzien As Byte
Dim Miesiac As Byte
Dim Dzien_tygodnia As Byte
Dim Klaw As Byte
Dim Poz As Byte
Dim Nr_ukladu_1(8) As Byte
Dim Nr_ukladu_2(8) As Byte
Dim T(9) As Byte
Dim Temp As Integer , Ulamek As Integer

Setfont Brzoza8x6

Wait 1

Dim Gbtemp1 As Byte                                         ' scratch byte
Gbtemp1 = Initfilesystem(1)

Call Init_eeprom

Call Sprawdz_dostepnosc_1wire

'sprawdzenie czy wcinieto S4, jeeli tak to bd dugie komunikaty
Klaw = 0                                                    'zmienna Mi=0 oznacza skrcone komunikaty
If Kl = 0 Then
   Waitms 25
   If Kl = 0 Then Klaw = 1
End If

Call Inicjuj_ds(klaw)

Call Odczyt_pcf(0)

Time$ = "17:25:00" : Date$ = "1.03.09"                      ' set the time and date

Call Wyswietl_temp

Do

   Call Odczyt_pcf(1)
   Wait 1

'   If Sekunda = 0 Then
      Call Wyswietl_temp
'   End If

   If S1 = 0 Then                                           ' jeeli wcinieto S1 to przechodzi do wywietlania temperatur minimalnych i maksymalnych
      Waitms 25
      If S1 = 0 Then
         Bitwait S1 , Set
         Poz = 1
         Do
            Cls
            Call Menu_glowne(poz)

            If Klaw = 2 Then
               Poz = Poz - 1
               If Poz = 0 Then Poz = 7
               Call Menu_glowne(poz)
            End If

            If Klaw = 3 Then
               Poz = Poz + 1
               If Poz = 8 Then Poz = 1
               Call Menu_glowne(poz)
            End If

            Klaw = Klawisz()

            If Klaw = 4 Then
               Cls
               Select Case Poz
                  Case 3 : Call Lcd_eeprom_graf
                  Case 4 : Call Ustaw_czas
                  Case 5 : Call Ustaw_date
                  Case 7 : Poz = 10
               End Select
            End If
         Loop Until Poz = 10
         Call Wyswietl_temp
      End If
   End If

Loop



End                                                         'end program

'*******************************************************************************
'*                         Procedury i funkcje                                 *
'*******************************************************************************

'===============================================================================
'=            Procedura odczytu danych z EEPROM i wyswitlenie na LCD           =
'= odczyt danych z eeprom od poczdku tablicy do iloci zapisanych pomiarw    =
'===============================================================================

Sub Lcd_eeprom_graf
Local Kom As Word , Kom_kol As Word
Local Temp_1 As Integer
Local Kol As Byte
Local Pozycja As Byte
Local X As Byte
Local X_1 As Byte , X_2 As Byte
Local Odcz As Byte

'Dbg
   X = 34
   Odcz = 4

   Do
      Readeeprom Kom , 61
      Kom_kol = 63

      Cls

      Line(1 , X) -(128 , X) , 1                            'os X
      X_1 = X - 2 : X_2 = X -1
      Line(125 , X_1) -(126 , X_2) , 1                      'strzaka X
      X_1 = X + 2 : X_2 = X + 1
      Line(125 , X_1) -(126 , X_2) , 1
      X_1 = X -1 : X_2 = X + 1                              'podziaki osi X
      For Kol = 13 To 123 Step 10
         Line(kol , X_1) -(kol , X_2) , 1
      Next

      Line(3 , 1) -(3 , 64) , 1                             'o Y
      Line(1 , 3) -(2 , 2) , 1                              'strzaka Y
      Line(5 , 3) -(4 , 2) , 1

      X_1 = X Mod 10                                        'podziaki osi Y
      For Kol = X_1 To 63 Step 10
         If Kol > 3 Then Line(2 , Kol) -(4 , Kol) , 1
      Next

      Pozycja = 4

      Do
         Readeeprom Temp , Kom_kol
         Kom_kol = Kom_kol + 2
         Readeeprom Temp_1 , Kom_kol
         Kom_kol = Kom_kol + 2
         Readeeprom Godzina , Kom_kol
         Kom_kol = Kom_kol + 1
         Readeeprom Minuta , Kom_kol
         Kom_kol = Kom_kol + 1
         Readeeprom Dzien , Kom_kol
         Kom_kol = Kom_kol + 1
         Readeeprom Miesiac , Kom_kol
         Kom_kol = Kom_kol + 1

         Temp = X - Temp
         If Temp > 4 Then
            If Temp < 63 Then Line(pozycja , Temp ) -(pozycja , Temp ) , 1
         End If

         Temp_1 = X - Temp_1
         If Temp_1 > 4 Then
            If Temp_1 < 63 Then Line(pozycja , Temp_1 ) -(pozycja , Temp_1 ) , 1
         End If
         Pozycja = Pozycja + 1
      Loop Until Kom_kol >= Kom

      Line(odcz , 1) -(odcz , 64) , 0

      X_1 = Odcz - 3
      Kom_kol = X_1 * 8
      Kom_kol = Kom_kol + 55

      Readeeprom Temp , Kom_kol
      Kom_kol = Kom_kol + 2
      Readeeprom Temp_1 , Kom_kol
      Kom_kol = Kom_kol + 2
      Readeeprom Godzina , Kom_kol
      Kom_kol = Kom_kol + 1
      Readeeprom Minuta , Kom_kol
      Kom_kol = Kom_kol + 1
      Readeeprom Dzien , Kom_kol
      Kom_kol = Kom_kol + 1
      Readeeprom Miesiac , Kom_kol
      Kom_kol = Kom_kol + 1

      Lcdat 1 , 100 , Temp ; Chr(131) ; "C"
      Lcdat 8 , 100 , Temp_1 ; Chr(131) ; "C"
      Lcdat 8 , 10 , Dzien ; "-" ; Miesiac ; " " ; Bcd(godzina) ; ":" ; Bcd(minuta)

      Klaw = Klawisz()
      Pozycja = Pozycja - 2
      If Klaw = 1 Then
       If Odcz <= Pozycja Then Odcz = Odcz + 1
       If Odcz = 121 Then Odcz = 4
      End If

      If Klaw = 2 Then
         X = X - 1
         If X = 3 Then X = 4
      End If

      If Klaw = 3 Then
         X = X + 1
         If X = 62 Then X = 61
      End If

   Loop Until Klaw = 4

   Cls
   Call Odczyt_pcf(0)                                       'poniewa byu uywane zmienne globalne dotyczace czasu nalezy je uaktualni

End Sub

'===============================================================================
'=                   Procedura wywietlenia temperatury                        =
'===============================================================================

Sub Wyswietl_temp
Local Stan As Byte
Local Kom As Word
Local Pasc As Byte
'Dbg
      Cls
      Setfont Font16x16

      Readeeprom Kom , 61                                   ' czytaj do kom adres wolnej komrki eeprom w ktrej mozna zapisa nowy pomiar
      If Kom > 841 Then Kom = 63                            'Jeeli ilo komrek przekroczy max eeprom wtedy kom ustawiamy na poczatek tablicy pomiarw

      For Poz = 1 To 2                                      'Petla dla 2 czujnikw DS18B20
         Stan = Czytaj()                                    'odczytanie temperatury w procedurze, sama funkcja zwraca numer bdu (opisane powyej)
         If Stan = 0 Then
            Select Case Temp
               Case -99 To -10 : Pasc = 0
               Case -1 To -9 : Pasc = 1
               Case 0 To 9 : Pasc = 2
               Case 10 To 99 : Pasc = 1
            End Select

            If Poz = 1 Then
               Lcdat 5 , 1 , Space(pasc) ; Temp ; "." ; Ulamek ; Chr(36) ; "C" ; " " , 1
                  Else
                     Lcdat 7 , 1 , Space(pasc) ; Temp ; "." ; Ulamek ; Chr(36) ; "C" ; " " , 1
            End If

            If Minuta = 0 Then
               Writeeeprom Temp , Kom                       'zapis wyniku pomiaru do eeprom
               Kom = Kom + 2                                'ustawinie wskazania na nastepna wolna kmrkie w eeprom
            End If
               Else
                  If Poz = 1 Then
                     Lcdat 5 , 1 , "--------"
                        Else
                           Lcdat 7 , 1 , "--------"
                  End If

                  If Minuta = 0 Then
                     Temp = 0
                     Writeeeprom Temp , Kom                 'zapis temperatur 0 w przypadku wystpienia bdu pomiaru do eeprom
                     Kom = Kom + 2                          'ustawinie wskazania na nastepna wolna kmrkie w eeprom
                  End If

         End If
      Next Poz

      If Minuta = 0 Then
         Writeeeprom Godzina , Kom                          'zapis do eeprom godziny pomiaru
         Kom = Kom + 1
         Writeeeprom Minuta , Kom                           'zapis do eeprom minuty pomiaru
         Kom = Kom + 1
         Writeeeprom Dzien , Kom                            'zapis do eeprom dnia pomiaru
         Kom = Kom + 1
         Writeeeprom Miesiac , Kom                          'zapis do eeprom miesica pomiaru
         Kom = Kom + 1
         Writeeeprom Kom , 61                               'zapis do eeprom wskazania na nastpn wolna komrke w eeprom
      End If

      Open "pom.log" For Append As #150                     ' we specify the file number now
      Print #150 , Temp ; "." ; Ulamek ; " - " ; Godzina ; ":" ; Minuta ; " " ; Dzien ; "-" ; Miesiac ; "-2009"
      Close #150

      Setfont Brzoza8x6
 End Sub

'===============================================================================
'=            Funkcja odczytu i konwersji temperatury z DS'w                  =
'=                                                                             =
'= wyjcie:                                                                    =
'=   Czytaj=0 gdy nie ma adych bedw odczytu danych                          =
'=   Czytaj=254 gdy wystpi bd transmisji, niezgodne CRC                    =
'=   Czytaj=255 gdy nie ma ID DS w EEPROM                                      =
'=   Temp - cz cakowita odczytanej temperatury                             =
'=   Ulamek - cz uamkowa odczytanej temperatury                            =
'= wejcie:                                                                    =
'=   poz - kolejny numer DS dla ktrego jest czytany pomiar temperatury          =
'===============================================================================
Function Czytaj() As Byte
Local Kom As Byte
Local I As Byte
Local Nazwa_ds As String * 8
'Dbg

   If Poz = 1 Then Kom = 3                                  ' w przypadku gdy czytamy dla pierwszego czujnika ustawiamy wskanik komrki eeprom na 3
   If Poz = 2 Then Kom = 20                                 ' w przypadku gdy czytamy dla pierwszego czujnika ustawiamy wskanik komrki eeprom na 20
   For I = 1 To 8                                           'wybr z EEPROM nr ukadu do odczytania
      Readeeprom Nr_ukladu_1(i) , Kom
      Kom = Kom + 1
   Next
   If Nr_ukladu_1(1) = &HFF Then                            'W przypadku braku ID DS'a w EEPROM funkcja zwraca kod bdu 255
         Czytaj = 255
         Nazwa_ds = "    Brak"                              'Poniewaz brak ID DS'a w EEPROM podstawiamy nazwe DS'a jako "Brak"
         Exit Function
   End If
   Readeeprom Nazwa_ds , Kom                                'Czytamy z EEPROM nazwe dla aktualnego DS'a
   1wreset                                                  ' reset the bus
   1wwrite &HCC                                             ' skip rom
   1wwrite &H44                                             ' Convert T                                                  ' "Convert ALL T on the 1w-bus"
   Waitus 200 : Waitus 200 : Waitus 200 : Waitus 200        'if you use 2-wire, could be reduced to 200us

   1wverify Nr_ukladu_1(1)                                  'Issues the "Match ROM "
   If Err = 1 Then
      Czytaj = 255                                          ' Warto Czytaj=255 oznacza brak DS na lini 1wire
         Else
            If Err = 0 Then
               1wwrite &HBE
               T(1) = 1wread(9)
               If T(9) = Crc8(t(1) , 8) Then
                  Temp = Makeint(t(1) , T(2))               'czymy bajty w zmienn typu INTEGER (-32,768 Do +32,767)
                  Temp = Temp / 16                          ' pozbywamy si czci uamkowej
                  T(1) = T(1) * 16                          ' tu obliczamy  uamek - pozbywamy si 4 najstarszych bitw
                  T(1) = T(1) / 16
                  Ulamek = T(1) * 625                       ' mnoymy przez rozdzielczo czujnika
                  If T(2) > 127 Then Ulamek = 10000 - Ulamek       ' jeli temp ujemna to przeliczamy cz uamkow i nie jest w aden sposb zwizana z procedur odczytu z czujnikw
                  Czytaj = 0                                'Warto Czytaj=0 oznacza brak bedw podczas odczytu i konwersji temperatury
                  If Ulamek = 625 Then
                     Ulamek = 0
                        Else
                           Ulamek = Ulamek / 1000
                  End If

                  If Temp = 85 Then                         'sprawdzenie czy nie wypisuje mi bzdury trafia sie odczty 85 stopni celciusza - nie wiem dlaczego
                     Czytaj = 254
                  End If

                  If Ulamek = 10 Then Ulamek = 1
                     Else
                        Czytaj = 254                        ' Czytaj=254 oznacza bd transmisji danych po 1wire
               End If
            End If
   End If
End Function

'===============================================================================
'=                Procedura sprawdzenia czy s 1wire na lini                   =
'=  Wyjscie z procedury tylko pod warunkiem e jest jaki 1wire na linii       =
'===============================================================================

Sub Sprawdz_dostepnosc_1wire
Local Kom As Byte
'Dbg

'Sprawdzenie czy na 1wire s ukady
 1wreset                                                    'reset magistrali 1wire
 If Err = 1 Then                                            'jezeli uklad dolaczony do magistali nie odpowiada do err=1 i
    Cls
    Kom = Lcdatcenter( "Brak ukladu" , 0 , 6)
    Lcdat 2 , Kom , "Brak ukladu"
    Kom = Lcdatcenter( "Dolacz uklady DS18B20" , 0 , 6)
    Lcdat 4 , Kom , "Dolacz uklady DS18B20"
  Do
   1wreset
  Loop Until Err = 0                                        'petla do-loop w celu wstrzymania programu do czasu podlaczenia urzadzenia
  Cls
 End If
End Sub

'===============================================================================
'=              Funkcja wywietlenia ciagu na srdoku LCD 128x64                =
'= Parametry:                                                                  =
'=    wiersz - numer wiersza do wywietlenia                                   =
'=    ciag   - string do wywietlenia                                          =
'=    dod    - ilo dodatkowych znakw do wywietlenia poza cigiem           =
'=    roz    - szeroko w punktach wywietlanej czcionki                      =
'===============================================================================

Function Lcdatcenter(byval Ciag As String , Byval Dod As Byte , Byval Roz As Byte) As Byte

Local Dl As Byte
'Dbg

   Dl = Len(ciag)
   Dl = Dl * Roz
   Dl = Dl + Dod
   Dl = 128 - Dl
   Dl = Dl / 2
   Lcdatcenter = Dl
End Function

'===============================================================================
'=              Procedura dodania nowego DS do EEPROM                          =
'===============================================================================

Sub Dodaj_ds_do_eeprom(byval Wys As Byte)

Local Wartosc As Byte
Local Kom As Byte
Local Kol As Byte
Local Nazwa_ds As String * 20
'Dbg

'Sprawdzenie czy pozycja 1 w EEPROM jest wolna
   Readeeprom Wartosc , 3
   If Wartosc = &HFF Then                                   'Jeeli pozycka 1 w EEPROM wolna to zapisz do niej DS
      Kom = 3
      For Kol = 1 To 8
         Writeeeprom Nr_ukladu_1(kol) , Kom
         Kom = Kom + 1
      Next A
      Nazwa_ds = "Czujnik1"
      Writeeeprom Nazwa_ds , 11
      If Wys = 1 Then
         Cls
         Kom = Lcdatcenter( "Dodano DS" , 0 , 6)
         Lcdat 1 , Kom , "Dodano DS"
         Lcdat 2 , 1 , Nazwa_ds
         Kom = Lcdatcenter( "do EEPROM" , 0 , 6)
         Lcdat 3 , Kom , "do EEPROM"
         Kom = Lcdatcenter( "Dodano DS" , 0 , 6)
         Lcdat 4 , Kom , "na pozycji 1"
         Wait 3
      End If
      Exit Sub
   End If

   Readeeprom Wartosc , 20
   If Wartosc = &HFF Then                                   'Jeeli pozycka 1 w EEPROM wolna to zapisz do niej DS
      Kom = 20
      For Kol = 1 To 8
         Writeeeprom Nr_ukladu_1(kol) , Kom
         Kom = Kom + 1
      Next A
      Nazwa_ds = "Czujnik2"
      Writeeeprom Nazwa_ds , 28
      If Wys = 1 Then
         Cls
         Kom = Lcdatcenter( "Dodano DS" , 0 , 6)
         Lcdat 1 , Kom , "Dodano DS"
         Lcdat 2 , 1 , Nazwa_ds
         Kom = Lcdatcenter( "do EEPROM" , 0 , 6)
         Lcdat 3 , Kom , "do EEPROM"
         Kom = Lcdatcenter( "Dodano DS" , 0 , 6)
         Lcdat 4 , Kom , "na pozycji 2"
         Wait 3
      End If
      Exit Sub
   End If
End Sub

'===============================================================================
'=                Procedura inicjacji DS na ilni 1wire                         =
'= wejcie:                                                                    =
'=  Kom (Mi) = 0  nie wywietlanie komunikatw na lcd komunikaty               =
'=  Kom (Mi) = 1  wywietlanie komunikatw na lcd komunikaty                   =
'===============================================================================

Sub Inicjuj_ds(wys As Byte)

Local Ilosc As Byte
Local Kolejny As Byte
Local A As Byte
Local Kom As Byte
Local Spr As Byte
'Dbg

   Cls

'Sprawdzenie ile jest DS na linii
   Ilosc = 1wirecount()

   If Wys = 1 Then
      Cls
      Kom = Lcdatcenter( "Liczba podlaczonych" , 0 , 6)
      Lcdat 1 , Kom , "Liczba podlaczonych"
      Lcdat 3 , 24 , "ukladow 1wire"
      Lcdat 4 , 58 , Ilosc
      Wait 3
   End If


 Nr_ukladu_1(1) = 1wsearchfirst()                           'pobieramy nr pierwszego ukadu
   For Kolejny = 1 To 2

       If Nr_ukladu_1(8) = Crc8(nr_ukladu_1(1) , 7) Then    ' Sprawdzenie sumy kontrolnej otrzymanych danych
         If Nr_ukladu_1(1) = &H28 Then                      'Sprawdzenie czy na 1wire jest DS18B20 (&H28)
            Kom = 3                                         ' Czytam z eeprom od komrki nr 3
            For A = 1 To 8
               Readeeprom Nr_ukladu_2(a) , Kom              'zapisuje do Nr_Ukadu2() dane ds_id z komrki eeprom
               Kom = Kom + 1
            Next A

            Spr = 1
            For A = 1 To 7                                  'Porwnuje NS DS z lini z DS z eeprom
               If Nr_ukladu_1(a) <> Nr_ukladu_2(a) Then
                  Spr = 0
                  Exit For
               End If
            Next A                                          'Jeeli ss=1 to DS jest w EEPROM na pozycji 1

            If Spr = 0 Then                                 'Jeeli ss=0 to DS nie ma w EEPROM na pozycji 1
               Kom = 20                                     ' Czytam z eeprom od komrki nr 20
               For A = 1 To 8
                  Readeeprom Nr_ukladu_2(a) , Kom           'zapisuje do Nr_Ukadu2() dane ds_id z komrki eeprom
                  Kom = Kom + 1
               Next A

               Spr = 1
               For A = 1 To 7                               'Porwnuje NS DS z lini z DS z eeprom
                  If Nr_ukladu_1(a) <> Nr_ukladu_2(a) Then
                     Spr = 0
                     Exit For
                  End If
               Next A
            End If
'Wyswietlenie informacji w ktrej komrce EEPROM znaleziono DS
            If Spr <> 0 Then
               If Wys = 1 Then
                  Cls
                  Lcdat 1 , 1 , "Znany czujnik " ; Kolejny
                  Wait 3
               End If
                  Else
                     If Wys = 1 Then
                        Cls
                        Lcdat 1 , 1 , "Znaleziono nowy " ; Kolejny
                        Wait 3
                     End If
                     Call Dodaj_ds_do_eeprom(1)
            End If
' wykonywanie w przypadku znalezienia innego 1wire ni DS18B20
              Else
               If Wys = 1 Then
                  Cls
                  Lcdat 1 , 2 , "Na lini 1wire"
                  Lcdat 2 , 1 , "znaleziono inny"
                  Lcdat 3 , 3 , "uklad niz"
                  Lcdat 4 , 4 , "DS18B20"
                  Wait 3
               End If
         End If
'Wykonywane w przypadku bdu CRC odebranych danych wywietla poniszy komunikat
            Else
               If Wys = 1 Then
                  Cls
                  Lcdat 1 , 6 , "Blad"
                  Lcdat 2 , 3 , "odebranych"
                  Lcdat 3 , 5 , "danych"
                  Wait 3
               End If
      End If
'Wolamy na 1wire nastepny dolaczony uklad
      Nr_ukladu_1(1) = 1wsearchnext()
   Next Kolejny
   Cls
End Sub

'===============================================================================
'=         Procedura ustawienia przez uytkownika daty                         =
'===============================================================================
Sub Ustaw_date

Local N_m As String * 12
Local Rok As Word
Local R As Byte
Local Yd As Byte
Local Wm As Byte
Local Wys As Byte
'Dbg

   Readeeprom Rok , &H1
   Wys = 1
'   D = Makedec(d)
'   Mi = Makedec(mi)
'   Dzien = Makebcd(dzien)
'   Miesiac = Makebcd(miesiac)

   Do
      Cls
      Lcdat 1 , 37 , "Ust. daty"
      Lcdat 3 , 40 , Bcd(dzien) ; "-" ; Bcd(miesiac) ; "-" ; Rok

      Select Case Wys
         Case 1 : Lcdat 3 , 40 , Bcd(dzien) , 1
         Case 2 : Lcdat 3 , 58 , Bcd(miesiac) , 1
         Case 3 : Lcdat 3 , 77 , Rok , 1
      End Select

      Klaw = Klawisz()

      If Klaw = 1 Then
         Wys = Wys + 1
         If Wys = 4 Then Wys = 1
      End If

      If Klaw = 2 Then
         If Wys = 1 Then
            Dzien = Dzien + 1
            If Dzien > 31 Then Dzien = 1
         End If

         If Wys = 2 Then
            Miesiac = Miesiac + 1
            If Miesiac > 12 Then Miesiac = 1
         End If

         If Wys = 3 Then
            Rok = Rok + 1
            If Rok > 2015 Then Rok = 2008
         End If
      End If

      If Klaw = 3 Then
         If Wys = 1 Then
            Dzien = Dzien - 1
            If Dzien = 0 Then Dzien = 31
         End If

         If Wys = 2 Then
            Miesiac = Miesiac - 1
            If Miesiac = 0 Then Miesiac = 12
         End If

         If Wys = 3 Then
            Rok = Rok - 1
            If Rok = 2008 Then Rok = 2015
         End If
      End If


 '     Cls
 '     Lcdat 1 , 37 , "Ust. daty"
 '     Lcdat 3 , 40 , Dzien ; "-" ; Miesiac ; "-" ; Rok

   Loop Until Klaw = 4

   Do
      N_m = Lookupstr(dzien_tygodnia , Dni_tygodnia )
      Cls
      Lcdat 1 , 10 , "Ust. dnia tygodnia"
      Lcdat 3 , 28 , N_m

      Klaw = Klawisz()

      If Klaw = 1 Then
         Dzien_tygodnia = Dzien_tygodnia + 1
         If Dzien_tygodnia > 7 Then Dzien_tygodnia = 1
      End If


      Cls
      N_m = Lookupstr(dzien_tygodnia , Dni_tygodnia )
      Lcdat 1 , 10 , "Ust. dnia tygodnia"
      Lcdat 3 , 28 , N_m

   Loop Until Klaw = 4

   Writeeeprom Rok , &H1

   R = Rok Mod 4

   Dzien = Makebcd(dzien)
   Miesiac = Makebcd(miesiac)
   R = R * 64
   Yd = R + Dzien
   Dzien_tygodnia = Dzien_tygodnia * 32
   Wm = Dzien_tygodnia + Miesiac
   I2cstart
   I2cwbyte 160
   I2cwbyte 0
   I2cwbyte 0
   I2cstop
   I2cstart
   I2cwbyte 160
   I2cwbyte 5
   I2cwbyte Yd
   I2cwbyte Wm
   I2cstop

   'Klaw = 1

End Sub

'===============================================================================
'=         Procedura ustawienia przez uytkownika czasu                        =
'===============================================================================
Sub Ustaw_czas
'Dbg

 Cls
 Lcdat 1 , 28 , "Ust. godziny"
 Lcdat 3 , 40 , Godzina ; ":" ; Minuta ; ":" ; Sekunda

 Do

  Klaw = Klawisz()

  If Klaw = 1 Then
   Godzina = Godzina + 1
   If Godzina > 23 Then Godzina = 0
  End If

  If Klaw = 2 Then
   Minuta = Minuta + 1
   If Minuta > 59 Then Minuta = 0
  End If

  If Klaw = 3 Then
   Sekunda = Sekunda + 1
   If Sekunda > 59 Then Sekunda = 0
  End If

  Cls
  Lcdat 1 , 28 , "Ust. godziny"
  Lcdat 3 , 40 , Godzina ; ":" ; Minuta ; ":" ; Sekunda

 Loop Until Klaw = 4

 Sekunda = Makebcd(sekunda)
 Minuta = Makebcd(minuta)
 Godzina = Makebcd(godzina)

 I2cstart
 I2cwbyte 160
 I2cwbyte 0
 I2cwbyte 0
 I2cstop
 I2cstart
 I2cwbyte 160
 I2cwbyte 2
 I2cwbyte Sekunda
 I2cwbyte Minuta
 I2cwbyte Godzina
 I2cstop

 Sekunda = Makedec(sekunda)
 Minuta = Makedec(minuta)
 Godzina = Makedec(godzina)

 ' Klaw = 1

End Sub

'===============================================================================
'=                   Procedura wywietlania menu gwnego                      =
'===============================================================================
Sub Menu_glowne(poz As Byte)
'Dbg
   Lcdat 1 , 30 , "Menu glowne" , 1
   Lcdat 2 , 1 , "1-Min-Max pomiar 1" , 0
   Lcdat 3 , 1 , "2-Min-Max pomiar 2" , 0
   Lcdat 4 , 1 , "3-Prezent. graficzna" , 0
   Lcdat 5 , 1 , "4-Ustawinie czasu" , 0
   Lcdat 6 , 1 , "5-Ustawinie daty" , 0
   Lcdat 7 , 1 , "6-Informacje" , 0
   Lcdat 8 , 1 , "7-Wyjscie" , 0

   Select Case Poz
      Case 1 : Lcdat 2 , 1 , "1-Min-Max pomiar 1" , 1
      Case 2 : Lcdat 3 , 1 , "2-Min-Max pomiar 2" , 1
      Case 3 : Lcdat 4 , 1 , "3-Prezent. graficzna" , 1
      Case 4 : Lcdat 5 , 1 , "4-Ustawinie czasu" , 1
      Case 5 : Lcdat 6 , 1 , "5-Ustawinie daty" , 1
      Case 6 : Lcdat 7 , 1 , "6-Informacje" , 1
      Case 7 : Lcdat 8 , 1 , "7-Wyjscie" , 1
   End Select

End Sub

'===============================================================================
'=                Funkcja sprawdzania wcinietego klawisza                     =
'=    Funkcja czeka na wcisnicie klawisza a nastpnie na jego puszczenie      =
'=                                                                             =
'=     Klawisz=1 gdy wcisnieto i puszczono S1                                  =
'=     Klawisz=2 gdy wcisnieto i puszczono S2                                  =
'=     Klawisz=3 gdy wcisnieto i puszczono S3                                  =
'=     Klawisz=4 gdy wcisnieto i puszczono S4                                  =
'===============================================================================
Function Klawisz() As Byte
'Dbg

  Bitwait Kl , Reset                                        ' Czekaj na wcinicie klawisza

  If S1 = 0 Then
  Waitms 25
   If S1 = 0 Then
    Klawisz = 1
   End If
 End If

 If S2 = 0 Then
  Waitms 25
   If S2 = 0 Then
    Klawisz = 2
   End If
 End If

  If S3 = 0 Then
  Waitms 25
   If S3 = 0 Then
    Klawisz = 3
   End If
 End If

  If S4 = 0 Then
  Waitms 25
   If S4 = 0 Then
    Klawisz = 4
   End If
 End If
 Bitwait Kl , Set
End Function

'===============================================================================
'=         Procedura odczytu danych z PCF'a oraz ich wywietlenie              =
'= parametry:                                                                  =
'=    1 - godzina, minuta, sekunda czcionka 16x16 w 1 linii                    =
'=        dzien, nazwa miesica, rok czcionka 8x8 w 3 linii                    =
'===============================================================================

Sub Odczyt_pcf(byval Stan As Byte)

Local N_m As String * 12
Local Yd As Byte
Local Wm As Byte
Local Rok As Word
Local R As Byte
'Dbg

   I2cstart                                                 ' odczytanie informacji z PCF
   I2cwbyte 160
   I2cwbyte 2
   I2cstart
   I2cwbyte 161
   I2crbyte Sekunda , Ack
   I2crbyte Minuta , Ack
   I2crbyte Godzina , Ack
   I2crbyte Yd , Ack
   I2crbyte Wm , Nack
   I2cstop

   R = Yd                                                   ' konwersja odczytanych informacji o roku, dniu tygodnia, dniu tygonia i miesicu
   Shift R , Right , 6
   Dzien = R
   Shift Dzien , Left , 6
   Dzien = Yd - Dzien
   Dzien = Makedec(dzien)

   Dzien_tygodnia = Wm
   Shift Dzien_tygodnia , Right , 5
   Miesiac = Dzien_tygodnia
   Shift Miesiac , Left , 5
   Miesiac = Wm - Miesiac
   Miesiac = Makedec(miesiac)
   Shift Godzina , Left , 2
   Shift Godzina , Right , 2

   If Stan = 1 Then
      Setfont Font16x16
      Lcdat 1 , 1 , Bcd(godzina) ; ":" ; Bcd(minuta) ; ":" ; Bcd(sekunda)

      N_m = Lookupstr(miesiac , Miesiace)                   'pobranie z eeprom sownej nazwy miesiaca
      Wm = Len(n_m)                                         'wyliczenie pozycji wywietlania daty
      Wm = Wm + 8
      Wm = Wm * 6
      Wm = 128 - Wm
      Wm = Wm / 2

      Readeeprom Rok , &H1                                  'pobranie roku z eerorm

      Setfont Brzoza8x6
      Lcdat 3 , Wm , Dzien ; " " ; N_m ; " " ; Rok          'wywietlenie daty

      N_m = Lookupstr(dzien_tygodnia , Dni_tygodnia)        'pobranie z eeprom nazwy dznia tygodnia
      Wm = Len(n_m)
      Wm = Wm * 6
      Wm = 128 - Wm
      Wm = Wm / 2
      Lcdat 4 , Wm , N_m                                    'wyswietlenie dnia tygodnia
   End If

   Godzina = Makedec(godzina)                               'zmiana formatu z kody BCD ma dziesietny
   Minuta = Makedec(minuta)
   Sekunda = Makedec(sekunda)
   Miesiac = Makedec(miesiac)
   Dzien_tygodnia = Makedec(dzien_tygodnia)

End Sub

'===============================================================================
'=              Procedura inicjacji adresu tablicy EEPROM                      =
'===============================================================================

Sub Init_eeprom
Local Rok As Word

'Dbg

   Readeeprom Rok , &H1

   If Rok = &HFFFF Then
      Rok = 2009
      Writeeeprom Rok , &H1
   End If

'W przypadku gdy program jest uruchamiany pierwszy raz komrka zawierajca adres poczadku tablicy ma warto &HFF, wtedy zmienia si na &H3D (63)      =
   Readeeprom Rok , &H61
   If Rok = &HFFFF Then
      Rok = 63
      Writeeeprom Rok , 61
   End If
End Sub
'==============================================================================
'=                   Doczenie plikw pomocniczych                           =
'==============================================================================

$include Brzoza.font                                        ' doaczenie pliku fontw 8x6
$include Font16x16.font                                     ' Doaczenie fontw 16x16
$include Dane.dat
'**************************************************************************


'Opis bitw seryjnych DS18B20
'Nr_ukladu(1) = family code           'Ds1820 10h, DS18B20 28h, Ds18s20 10h
'Nr_ukladu(2)                         '48 Bits Serial, LSB
'Nr_ukladu(3)
'Nr_ukladu(4)
'Nr_ukladu(5)
'Nr_ukladu(6)
'Nr_ukladu(7)                         '48 Bits Serial, MSB
'Nr_ukladu(8)                         '8 CRC

'Opis bitw danych DS18B20
'Biezacy(1)                           'Temperature LSB
'Biezacy(2)                           'Temperature MSB
'Biezacy(3)                           'TH/user byte 1         also SRAM
'Biezacy(4)                           'TL/user byte 2         also SRAM
'Biezacy(5)                           'config                 also SRAM    x R1 R0 1 1 1 1 1 - the r1 r0 are config for resolution - write FF to byte for 12 bit - others dont care
'Biezacy(6)                           'res
'Biezacy(7)                           'res
'Biezacy(8)                           'res
'Biezacy(9)                           '8 CRC

'Opis komend DS18B20
'&H 33  read rom - single sensor
'&H 55  match rom, followed by 64 bits
'&H CC  skip rom
'&H EC  alarm search  - ongoining alarm >TH <TL
'&H BE  read scratchpad
'&H 44  convert T

'Mapa pamici EEPROM
'LP  Ilow  Adr.   Adr.  Opis
'    bitw start  stop
'1     2      1 -   2   Rok
'2     8      3 -  10   Id Ds. Nr 1
'      8+1   11 -  19   Nazwa DS. nr 1
'3     8     20 -  27   ID DS. nr 2
'      8+1   28 -  36   Nazwa DS. nr 2
'      2     37 -  38   Min DS 1
'      1     39 -  39   Min godzina DS 1
'      1     40 -  40   Min minuta DS 1
'      1     41 -  41   Min dzie DS 1
'      1     42 -  42   Min miesiac DS 1
'      2     43 -  44   Max DS 1
'      1     45 -  45   Max godzina DS 1
'      1     46 -  46   Max minuta DS 1
'      1     47 -  47   Max dzie DS 1
'      1     48 -  48   Max miesiac DS 1
'      2     49 -  50   Min DS 2
'      1     51 -  51   Min godzina DS 2
'      1     52 -  52   Min minuta DS 2
'      1     53 -  53   Min dzie DS 2
'      1     54 -  54   Min miesiac DS 2
'      2     55 -  56   Max DS 2
'      1     57 -  57   Max godzina DS 2
'      1     58 -  58   Max minuta DS 2
'      1     59 -  59   Max dzie DS 2
'      1     60 -  60   Max miesiac DS 2
'      2     61 -  62   Adres komrki EEPROM do zapisu temperatury
'      1     63 -  64   Temperatura DS 1 =
'      2     65 -  66   Temperatura DS 2  |
'      1     67 -  67   Godzina DS        |
'      1     68 -  68   Minuta DS         | 8 bitw na sowo
'      1     69 -  69   Dzie DS          |
'      1     70 -  70   Miesiac DS       =
'      1     71 -  72   Temperatura DS 1 =
'      2     73 -  74   Temperatura DS 2  |
'      1     75 -  75   Godzina DS        |
'      1     76 -  76   Minuta DS         | 8 bitw na sowo
'      1     77 -  77   Dzie DS          |
'      1     78 -  78   Miesiac DS       =



'KODY BEDW zmiennej TEMP
' Temp=255 - brak wywoywanego DS na linii 1wire
' Temp-254 - bd komunikacji z DS na linii 1wire

'Dataport = Porta , Controlport = Portd , Ce = 6 , Ce2 = 7 , Cd = 4 , Rd = 3 , Reset = 2 , Enable = 5

'The dataport is the portname that is connected to the data lines of the LCD
'The controlport is the portname which pins are used to control the lcd
'CE =CS1  Chip select               = CS1 (2)
'CE2=CS2  Chip select second chip   = CS2 (1)
'CD=Data/instruction                = RS  (6)
'RD=Read                            = RW  (7)
'RESET = reset
'ENABLE= Chip Enable                = E   (8)

' 1 - Ce     - CS1 - PD6
' 2 - Ce2    - CS2 - PD7
' 3 - GND
' 4 - VCC
' 5 - V0
' 6 - CD     - RS - PD4
' 7 - Rd     - RW - PD3
' 8 - Enable - E  - PD5
' 9 - Data        - PA0
'10 - Data        - PA1
'11 - Data        - PA2
'12 - Data        - PA3
'13 - Data        - PA4
'14 - Data        - PA5
'15 - Data        - PA6
'16 - Data        - PA7
'17 - diody LED   - VCC
'18 - diody LED   - GND

' OPIS PINW NA POLU TESTOWYM
' 1 - GND
' 2 - 4,7 K z VCC
' 3 -
' 4 -
' 5 -
' 6 -
' 7 -
' 8 -
' 9 -
'10 - Vo
'11 - VCC
'12 - GND